<?php

require_once('/usr/local/www/berogui/misc/database.php');
require_once('/usr/local/php/include/fulltrace.Class.php');

class apiCall {

	private $_name, $_get, $_post, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'GatewayFulltrace';
		$this->_get = $get;
		$this->_post = $post;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		if (!isset($this->_get['performAction']) || empty($this->_get['performAction'])) {
			$this->_execResultString = 'error:missing_parameter_performAction';
			$this->_execResult = false;
			return($this->_execResult);
		}

		$db = new beroAri();
		$ft = new fulltrace();

		switch ($this->_get['performAction']) {
		case 'start':
			if ($db->get('trace') == 'yes') {
				$this->_execResultString = 'error:trace_alread_in_progress';
				$this->_execResult = false;
				return($this->_execResult);
			}

			$enable = array('isdn' => 1, 'analog' => 1, 'gsm' => 1);
			$enable['sip_sign'] =	(($this->_get['sipsig'] == 'yes')	? 1 : 0);
			$enable['sip_audio'] =	(($this->_get['sipaudio'] == 'yes')	? 1 : 0);
			$enable['rtp_udptl'] =	(($this->_get['rtp_udptl'] == 'yes')	? 1 : 0);
			$enable['any'] =	(($this->_get['any'] == 'yes')		? 1 : 0);
			$enable['lan'] =	(($this->_get['lan'] == 'yes')		? 1 : 0);
			$enable['lo'] =		(($this->_get['lo'] == 'yes')		? 1 : 0);
			$enable['syslog'] =	(($this->_get['syslog'] == 'yes')	? 1 : 0);

			$res = $db->select('SELECT port FROM isdn;');
			while ($entry = $db->fetch_array($res)) {
				$isdn_ports[] = $entry['port'];
			}
			unset($res);

			$ft->start($enable, $isdn_ports, null);
			break;
		case 'stop':
			$ft->stop(false);
			break;
		case 'download':
			if (!file_exists('/var/log/DebugFiles.tar.gz')) {
				$this->_execResultString = 'error:no_fulltrace_found';
				$this->_execResult = false;
			}
			break;
		default:
			$this->_execResultString = 'error:invalid_parameter_performAction';
			$this->_execResult = false;
			break;
		}

		return($this->_execResult);
	}

	function display () {
		if (($this->_get['performAction'] == 'download') && ($this->_execResult != false)) {
			$debugArchive = file_get_contents('/var/log/DebugFiles.tar.gz');
			header('Content-Type: application/force-download');
			header('Content-Disposition: attachment; filename=DebugFiles.tar.gz' . "\r\n\r\n");
			header('Content-Length: ' . strlen($debugArchive) . "\n\n");

			return($debugArchive);
		}

		return($this->_name . ':' . $this->_execResultString);
	}
}

?>
