<?php

class apiCall {

	private $_name, $_get, $_post, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'SmsGetMessage';
		$this->_get = $get;
		$this->_post = $post;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		if (!isset($this->_get['SmsQueue']) || !isset($this->_get['SmsIdentifier'])) {
			$this->_execResultString = 'error:invalid_parameters';
			$this->_execResult = false;
			return($this->_execResult);
		}

		$queuePath = '/tmp/sms/' .$this->_get['SmsQueue'];

		if (!file_exists($queuePath)) {
			$this->_execResultString = 'error:specified_queue_does_not_exist';
			$this->_execResult = false;
			return($this->_execResult);
		}

		switch($this->_get['SmsQueue']) {
		case 'in':
			$smsPath = $queuePath . '/' . $this->_get['SmsIdentifier'] . '.sms';
			$this->_execResultString .= "\n" . @file_get_contents($smsPath);
			if (isset($this->_get['Delete'])) {
				@unlink($smsPath);
			}
			break;
		case 'out':
			$smsPath = $queuePath . '/' . $this->_get['SmsIdentifier'] . '.sms';
			$this->_execResultString .= "\n" . @file_get_contents($smsPath) . "\n";
			$this->_execResultString .= "\n" . @file_get_contents($smsPath . '.log') . "\n";
			if (isset($this->_get['Delete'])) {
				@unlink($smsPath);
				@unlink($smsPath . '.log');
			}
			break;
		case 'failout':
			$smsPath = $queuePath . '/' . $this->_get['SmsIdentifier'] . '/';
			$this->_execResultString .= "\n" . @file_get_contents($smsPath . 'message') . "\n";
			$this->_execResultString .= "\n" . @file_get_contents($smsPath . 'message.log') . "\n";
			if (isset($this->_get['Delete'])) {
				@unlink($smsPath . 'message');
				@unlink($smsPath . 'message.log');
				@rmdir($smsPath);
			}
			break;
		}

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}
}

?>
